VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   4800
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3600
   ControlBox      =   0   'False
   Icon            =   "test.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   320
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   240
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer HowToPlayStart 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   1200
      Top             =   0
   End
   Begin VB.Timer GameStart 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   600
      Top             =   0
   End
   Begin VB.Timer TitleStart 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   0
      Top             =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'The following API calls are for:

'blitting
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

'code timer
Private Declare Function GetTickCount Lib "kernel32" () As Long

'creating buffers / loading sprites
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long

'loading sprites
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long

'cleanup
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

'end of copy-paste here...
'our Buffer's DC
Public myBackBuffer As Long
Public myBufferBMP As Long

'The DC of our sprite/graphic
Public myTitleScreen As Long
Public myHowToPlay As Long
Public myAZ As Long
Public my09 As Long
Public myBackground As Long
Public myPlayer As Long
Public myPlayerMask As Long
Public myFood As Long
Public myFoodMask As Long
Public myGameover As Long

Public TITLESELECTION As Long

Const STARTX = 120
Const STARTY = 300
Const STARTVX = 0#
Const STARTVY = -1#
Const SPEED1 = 70
Const SPEED2 = 100
Const SPEED3 = 160
Const RATE = 360# * 3.14159 / 180

Public Function LoadGraphicDC(sFileName As String) As Long
    'cheap error handling
    On Error Resume Next
    
    'temp variable to hold our DC address
    Dim LoadGraphicDCTEMP As Long
    
    'create the DC address compatible with
    'the DC of the screen
    LoadGraphicDCTEMP = CreateCompatibleDC(GetDC(0))
    
    'load the graphic file into the DC...
    SelectObject LoadGraphicDCTEMP, LoadPicture(sFileName)
    
    'return the address of the file
    LoadGraphicDC = LoadGraphicDCTEMP
End Function

Public Sub PrintNum(lBuffer As Long, X As Long, Y As Long, sNum As Long)
    Dim sTemp As String
    Dim pos As Long
    
    sTemp = CStr(sNum)
    pos = 0
    Do While Mid(sTemp, 1 + pos, 1) <> ""
        BitBlt lBuffer, X + pos * 10, Y, 10, 12, my09, Val(Mid(sTemp, 1 + pos, 1)) * 10, 0, vbSrcCopy
        pos = pos + 1
    Loop
End Sub

Public Sub PrintStr(lBuffer As Long, X As Long, Y As Long, sStr As String)
    Dim pos As Long
    
    pos = 0
    Do While Mid(sStr, 1 + pos, 1) <> ""
        If Mid(sStr, 1 + pos, 1) <> " " Then
            BitBlt lBuffer, X + pos * 10, Y, 10, 12, myAZ, (Asc(Mid(sStr, 1 + pos, 1)) - Asc("A")) * 10, 0, vbSrcCopy
        End If
        pos = pos + 1
    Loop
End Sub

Private Sub Init()
    myBackBuffer = CreateCompatibleDC(GetDC(0))
    myBufferBMP = CreateCompatibleBitmap(GetDC(0), 240, 320)
    SelectObject myBackBuffer, myBufferBMP
    
    myTitleScreen = LoadGraphicDC(App.Path & "\img\title.bmp")
    myHowToPlay = LoadGraphicDC(App.Path & "\img\howtoplay.bmp")
    myAZ = LoadGraphicDC(App.Path & "\img\az.bmp")
    my09 = LoadGraphicDC(App.Path & "\img\09.bmp")
    myBackground = LoadGraphicDC(App.Path & "\img\background.bmp")
    myPlayer = LoadGraphicDC(App.Path & "\img\player.bmp")
    myPlayerMask = LoadGraphicDC(App.Path & "\img\playermask.bmp")
    myFood = LoadGraphicDC(App.Path & "\img\food.bmp")
    myFoodMask = LoadGraphicDC(App.Path & "\img\foodmask.bmp")
    myGameover = LoadGraphicDC(App.Path & "\img\gameover.bmp")
End Sub

Private Sub Uninit()
    DeleteObject myBufferBMP
    DeleteDC myBackBuffer
    DeleteDC myTitleScreen
    DeleteDC myHowToPlay
    DeleteDC myAZ
    DeleteDC my09
    DeleteDC myBackground
    DeleteDC myPlayer
    DeleteDC myPlayerMask
    DeleteDC myFood
    DeleteDC myFoodMask
    DeleteDC myGameover
End Sub

Private Function Collide(X As Long, Y As Long, x2 As Long, y2 As Long, d As Long) As Boolean
    ' check dist between nodes less than d
    Collide = ((X - x2) ^ 2 + (Y - y2) ^ 2) ^ 0.5 <= d
End Function

Private Function OnTop() As Boolean
    OnTop = (GetForegroundWindow = Me.hwnd)
End Function

Private Sub Form_Load()
    Me.Caption = " Nibballz 1.00"
    Init ' load graphics
    TitleStart.Enabled = True
End Sub


Private Sub Form_Unload(Cancel As Integer)
    'MsgBox "hi"
    Uninit ' delete graphics
    Unload Me
End Sub

Private Sub GameStart_Timer()
    Randomize Timer
    GameStart.Enabled = False
    
    Dim T1 As Long, T2 As Long, T3 As Long
    Dim gameover As Boolean
    Dim Score As Long
    Dim Time As Long
    
    Dim playerSpeed As Long
    Dim playerTurnRate As Long
    Dim playerVX As Double, playerVY As Double
    Dim tempVX As Double, tempVY As Double
    Dim angle As Double
    Dim playerX As Double, playerY As Double
    Dim tailX As Double, tailY As Double
    Dim odometer As Double
    
    Dim foodX As Long, foodY As Long
    
    Dim toBeGrown As Long
    Dim headnode As Node
    Dim tempnode As Node
    Dim tempnode2 As Node
    
    Dim frameLapse As Double

    gameover = False
    Score = 0
    Time = 300
    
    playerSpeed = SPEED2
    playerTurnRate = RATE
    playerVX = STARTVX
    playerVY = STARTVY
    playerX = STARTX
    playerY = STARTY
    
    tailX = -16
    tailY = -16
    tailX2 = -16
    tailY2 = -16
    odometer = 0
    
    foodX = Int((Rnd * 224 + 8))
    foodY = Int((Rnd * 284 + 28))
    
    Set headnode = Nothing
    Set tempnode = Nothing
    Set tempnode2 = Nothing
    toBeGrown = 1
    
    
    
    T1 = GetTickCount
    T3 = T1
    T2 = T1 + 100
    Do: DoEvents
        T1 = GetTickCount
        frameLapse = (T1 - T3) / 1000
        ' draw
        BitBlt myBackBuffer, 0, 0, 240, 320, myBackground, 0, 0, vbSrcCopy
        PrintStr myBackBuffer, 5, 5, "SCORE"
        PrintNum myBackBuffer, 65, 5, Score
        PrintStr myBackBuffer, 240 - 5 - 80, 5, "TIME"
        PrintNum myBackBuffer, 240 - 5 - 30, 5, Time
        
        BitBlt myBackBuffer, playerX - 8, playerY - 8, 16, 16, myPlayerMask, 0, 0, vbSrcAnd
        BitBlt myBackBuffer, playerX - 8, playerY - 8, 16, 16, myPlayer, 0, 0, vbSrcPaint
        
        BitBlt myBackBuffer, tailX - 8, tailY - 8, 16, 16, myPlayerMask, 0, 0, vbSrcAnd
        BitBlt myBackBuffer, tailX - 8, tailY - 8, 16, 16, myPlayer, 0, 0, vbSrcPaint
        
        BitBlt myBackBuffer, tailX2 - 8, tailY2 - 8, 16, 16, myPlayerMask, 0, 0, vbSrcAnd
        BitBlt myBackBuffer, tailX2 - 8, tailY2 - 8, 16, 16, myPlayer, 0, 0, vbSrcPaint
        
        Set tempnode = headnode
        While Not tempnode Is Nothing
            BitBlt myBackBuffer, tempnode.X - 8, tempnode.Y - 8, 16, 16, myPlayerMask, 0, 0, vbSrcAnd
            BitBlt myBackBuffer, tempnode.X - 8, tempnode.Y - 8, 16, 16, myPlayer, 0, 0, vbSrcPaint
            Set tempnode = tempnode.NextNode
        Wend
        
        
        BitBlt myBackBuffer, foodX - 8, foodY - 8, 16, 16, myFoodMask, 0, 0, vbSrcAnd
        BitBlt myBackBuffer, foodX - 8, foodY - 8, 16, 16, myFood, 0, 0, vbSrcPaint
        
        'BitBlt myBackBuffer, playerX - 8, playerY - 8, 16, 16, myPlayer, 0, 0, vbSrcCopy

        BitBlt Me.hdc, 0, 0, 240, 320, myBackBuffer, 0, 0, vbSrcCopy
                
        ' controls
        If OnTop And GetAsyncKeyState(VK_LEFT) < 0 Then
            tempVX = playerVX
            tempVY = playerVY
            angle = playerTurnRate * frameLapse
            playerVX = tempVX * Cos(angle) + tempVY * Sin(angle)
            playerVY = tempVY * Cos(angle) - tempVX * Sin(angle)
        End If
        If OnTop And GetAsyncKeyState(VK_RIGHT) < 0 Then
            tempVX = playerVX
            tempVY = playerVY
            angle = -playerTurnRate * frameLapse
            playerVX = tempVX * Cos(angle) + tempVY * Sin(angle)
            playerVY = tempVY * Cos(angle) - tempVX * Sin(angle)
        End If
        If OnTop And GetAsyncKeyState(VK_UP) < 0 Then
            playerSpeed = SPEED3
        ElseIf OnTop And GetAsyncKeyState(VK_DOWN) < 0 Then
            playerSpeed = SPEED1
        Else
            playerSpeed = SPEED2
        End If
        If OnTop And GetAsyncKeyState(80) < 0 Then ' P - paused
            Do: DoEvents
            Loop Until GetAsyncKeyState(80) >= 0
            Do: DoEvents
                T1 = GetTickCount
                BitBlt myBackBuffer, 0, 0, 240, 320, 0, 0, 0, vbWhiteness
                PrintStr myBackBuffer, 90, 150, "PAUSED"
                BitBlt Me.hdc, 0, 0, 240, 320, myBackBuffer, 0, 0, vbSrcCopy
                T2 = T1
            Loop Until OnTop And GetAsyncKeyState(80) < 0
            Do: DoEvents
            Loop Until GetAsyncKeyState(80) >= 0
        End If
        If OnTop And GetAsyncKeyState(VK_ESCAPE) < 0 Then
            Do: DoEvents
            Loop Until GetAsyncKeyState(VK_ESCAPE) >= 0
            gameover = True
        End If
        
        ' collision
        playerX = playerX + (playerVX * playerSpeed * frameLapse)
        playerY = playerY + (playerVY * playerSpeed * frameLapse)
        odometer = odometer + playerSpeed * frameLapse
        If odometer > 9 Then ' tail move and grow
            odometer = odometer - 9
            
            If toBeGrown > 0 Then
                toBeGrown = toBeGrown - 1
                Set tempnode = New Node
                Let tempnode.X = tailX2
                Let tempnode.Y = tailY2
                Let tempnode.NextNode = headnode
                Set headnode = tempnode
            Else
                Set tempnode = headnode
                Set tempnode2 = tempnode
                While Not tempnode.NextNode Is Nothing
                    Set tempnode2 = tempnode
                    Set tempnode = tempnode.NextNode
                Wend
                
                Let tempnode.X = tailX2
                Let tempnode.Y = tailY2
                Let tempnode.NextNode = headnode
                Set headnode = tempnode
                Let tempnode2.NextNode = Nothing
            End If
            
            tailX2 = tailX
            tailY2 = tailY
            tailX = playerX
            tailY = playerY
            
        End If
        
        ' check if crash into tail
        Set tempnode = headnode
        While Not tempnode Is Nothing
            If Collide(Int(playerX), Int(playerY), tempnode.X, tempnode.Y, 8) Then
                gameover = True
            End If
            Set tempnode = tempnode.NextNode
        Wend
        
        
        If playerX < 4 Or playerX > 236 Or playerY < 24 Or playerY > 316 Then
            gameover = True
        End If
        
        If Collide(Val(playerX), Val(playerY), foodX, foodY, 16) Then
            foodX = Int((Rnd * 224 + 8))
            foodY = Int((Rnd * 284 + 28))
            Score = Score + 100
            Time = Time + 15
            toBeGrown = toBeGrown + 3
        End If
        
        ' time
        If T1 >= T2 Then
            T2 = T2 + 100
            Time = Time - 1
        End If
        If Time = 0 Then: gameover = True
        T3 = T1 ' T1 - T3 = framelapse
    Loop Until gameover
    
    ' display final score
    gameover = False
    Do: DoEvents
        BitBlt myBackBuffer, 0, 0, 240, 320, myGameover, 0, 0, vbSrcCopy
        PrintStr myBackBuffer, 65, 160, "FINAL SCORE"
        PrintNum myBackBuffer, 65, 180, Score
        PrintStr myBackBuffer, 65, 200, "TIME REMAINING"
        PrintNum myBackBuffer, 65, 220, Time
        BitBlt Me.hdc, 0, 0, 240, 320, myBackBuffer, 0, 0, vbSrcCopy

        If OnTop And GetAsyncKeyState(VK_RETURN) < 0 Then
            Do: DoEvents
            Loop Until GetAsyncKeyState(VK_RETURN) >= 0
            gameover = True
        End If
        If OnTop And GetAsyncKeyState(VK_ESCAPE) < 0 Then
            Do: DoEvents
            Loop Until GetAsyncKeyState(VK_ESCAPE) >= 0
            gameover = True
        End If
    Loop Until gameover
    
    Set headnode = Nothing
    Set tempnode = Nothing
    
    TitleStart.Enabled = True
End Sub

Private Sub HowToPlayStart_Timer()
    HowToPlayStart.Enabled = False
    
    Dim exithowtoplay As Boolean
    exithowtoplay = False
    Do: DoEvents
        BitBlt myBackBuffer, 0, 0, 240, 320, myHowToPlay, 0, 0, vbSrcCopy
        BitBlt Me.hdc, 0, 0, 240, 320, myBackBuffer, 0, 0, vbSrcCopy
        
        If OnTop And GetAsyncKeyState(VK_RETURN) < 0 Then
            Do: DoEvents
            Loop Until GetAsyncKeyState(VK_RETURN) >= 0
            exithowtoplay = True
        End If
        If OnTop And GetAsyncKeyState(VK_ESCAPE) < 0 Then
            Do: DoEvents
            Loop Until GetAsyncKeyState(VK_ESCAPE) >= 0
            exithowtoplay = True
        End If
    Loop Until exithowtoplay
    
    TitleStart.Enabled = True
End Sub

Private Sub TitleStart_Timer()
    TitleStart.Enabled = False
    
    TITLESELECTION = -1
    Dim T1 As Long, T2 As Long
    Dim selection As Long
    Dim X As Long
    selection = 0
    Do: DoEvents
        BitBlt myBackBuffer, 0, 0, 240, 320, myTitleScreen, 0, 0, vbSrcCopy
        BitBlt myBackBuffer, 45, 171 + selection * 33, 16, 16, myPlayerMask, 0, 0, vbSrcAnd
        BitBlt myBackBuffer, 45, 171 + selection * 33, 16, 16, myPlayer, 0, 0, vbSrcPaint
        
        BitBlt Me.hdc, 0, 0, 240, 320, myBackBuffer, 0, 0, vbSrcCopy
        
        If OnTop And GetAsyncKeyState(VK_UP) < 0 Then
            selection = (selection - 1)
            If selection < 0 Then: selection = 2
            Do: DoEvents
            Loop Until GetAsyncKeyState(VK_UP) >= 0
        End If
        If OnTop And GetAsyncKeyState(VK_DOWN) < 0 Then
            selection = (selection + 1) Mod 3
            Do: DoEvents
            Loop Until GetAsyncKeyState(VK_DOWN) >= 0
        End If
        If OnTop And GetAsyncKeyState(VK_RETURN) < 0 Then
            Do: DoEvents
            Loop Until GetAsyncKeyState(VK_RETURN) >= 0
            TITLESELECTION = selection
        End If
        If OnTop And GetAsyncKeyState(VK_ESCAPE) < 0 Then
            Do: DoEvents
            Loop Until GetAsyncKeyState(VK_ESCAPE) >= 0
            TITLESELECTION = 2
        End If
    Loop Until TITLESELECTION <> -1
    
    Select Case TITLESELECTION
    Case 0:
        GameStart.Enabled = True
    Case 1:
        HowToPlayStart.Enabled = True
    Case 2:
        Unload Me
    End Select
End Sub
